// AQUAMAN! - Made By AssKicR & Lazy <the_lazy_one_09@hotmail.com>
// Some sprite and code tweaks by JTP10181

/* CVARS - copy and paste to shconfig.cfg

//Aquaman
aquaman_level 0
aquaman_armorcost 0				//How much amour each bubble attack blast uses
aquaman_numbubbles 7			//How many giant killer bubbles
aquaman_bubbledamage 10			//How much damage each bubble does

*/

#include <amxmodx>
#include <engine>
#include <cstrike>
#include <shero>

// GLOBAL VARIABLES
new g_heroName[]="Aquaman"
new g_heroID
new bool:g_hasAquaman[SH_MAXSLOTS+1]
new bool:g_isBubbling[SH_MAXSLOTS+1]
new g_spriteBubble
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Aquaman", "2.0", "AssKicR/Lazy/JTP10181")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("aquaman_level", "0")
	register_cvar("aquaman_armorcost", "0")
	register_cvar("aquaman_numbubbles", "7")
	register_cvar("aquaman_bubbledamage", "10")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	g_heroID = sh_create_hero(g_heroName)
	sh_hero_info(g_heroID, "Gills & Bubble Attack", "You can Breathe Underwater and Fire your Bubble Attack")
	sh_hero_bind(g_heroID, true)
	sh_hero_level(g_heroID, get_cvar_num("aquaman_level"))

	set_task(1.0, "UnderTheSea", 0, "", 0, "b")
}
//----------------------------------------------------------------------------------------------
public plugin_precache()
{
	g_spriteBubble = precache_model("sprites/bubble.spr")
	precache_sound("scientist/scream1.wav")
	precache_sound("vox/_period.wav")
}
//----------------------------------------------------------------------------------------------
public sh_hero_init(id, heroID, mode)
{
	// See if this hero is the same that's being init
	if ( g_heroID == heroID )
		g_hasAquaman[id] = (mode != 0)
}
//----------------------------------------------------------------------------------------------
public UnderTheSea()
{
	if ( !sh_server_info(SH_MODACTIVE) )
		return

	for( new i = 1; i <= SH_MAXSLOTS; i++ )
	{
		if ( g_hasAquaman[i] && is_user_alive(i) )
		{
			if ( entity_get_int(i, EV_INT_waterlevel) == 3 )
				entity_set_float(i, EV_FL_air_finished, entity_get_float(i, EV_FL_air_finished) + 2.0)
		}
	}
}
//----------------------------------------------------------------------------------------------
// -|-LoA-|-Bass's Bubble thrower
public sh_hero_key(id, heroID, key)
{
	if ( g_heroID != heroID || key != SH_KEYDOWN ) return
	if ( !sh_server_info(SH_INROUND) ) return
	if ( !is_user_alive(id) || !g_hasAquaman[id] ) return

	if ( entity_get_int(id, EV_INT_waterlevel) != 3 )
	{
		client_print(id, print_chat, "[SH](%s) You must be underwater to use the Bubble Attack", g_heroName)
		playSoundDenySelect(id)
		return
	}

	new armorCost = get_cvar_num("aquaman_armorcost")

	if ( armorCost > 0 )
	{
		// Armor type doesn't concern us we do nothing with it, but we need the place holder
		new CsArmorType:armorType
		new userArmor = cs_get_user_armor(id, armorType)

		if ( userArmor < armorCost )
		{
			client_print(id, print_chat, "[SH](%s) Bubble Attacks cost %d armor point%s each", g_heroName, armorCost, armorCost == 1 ? "" : "s")
			playSoundDenySelect(id)
			return
		}

		cs_set_user_armor(id, userArmor - armorCost, CS_ARMOR_VESTHELM)
	}

	emit_sound(id, CHAN_WEAPON, "player/pl_swim3.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

	new vec[3]
	new aimvec[3]
	new velocityvec[3]
	new length
	new speed = 10
	get_user_origin(id, vec)
	get_user_origin(id, aimvec, 2)
	new dist = get_distance(vec, aimvec)

	new speed1 = 160
	new speed2 = 350
	new radius = 105

	if (dist < 50)
	{
		radius = 0
		speed = 5
	}
	else if (dist < 150)
	{
		speed1 = speed2 = 1
		speed = 5
		radius = 50
	}
	else if (dist < 200)
	{
		speed1 = speed2 = 1
		speed = 5
		radius = 90
	}
	else if (dist < 250)
	{
		speed1 = speed2 = 90
		speed = 6
		radius = 90
	}
	else if (dist < 300)
	{
		speed1 = speed2 = 140
		speed = 7
	}
	else if (dist < 350)
	{
		speed1 = speed2 = 190
		speed = 7
	}
	else if (dist < 400)
	{
		speed1 = 150
		speed2 = 240
		speed = 8
	}
	else if (dist < 450)
	{
		speed1 = 150
		speed2 = 290
		speed = 8
	}
	else if (dist < 500)
	{
		speed1 = 180
		speed2 = 340
		speed = 9
	}

	velocityvec[0] = aimvec[0]-vec[0]
	velocityvec[1] = aimvec[1]-vec[1]
	velocityvec[2] = aimvec[2]-vec[2]

	length = sqrt(velocityvec[0]*velocityvec[0] + velocityvec[1]*velocityvec[1] + velocityvec[2]*velocityvec[2])

	// Make sure 0 is not returned so we don't devide by it
	if ( length == 0 ) length++

	velocityvec[0] = velocityvec[0]*speed/length
	velocityvec[1] = velocityvec[1]*speed/length
	velocityvec[2] = velocityvec[2]*speed/length

	new args[6]
	args[0] = vec[0]
	args[1] = vec[1]
	args[2] = vec[2]
	args[3] = velocityvec[0]
	args[4] = velocityvec[1]
	args[5] = velocityvec[2]
	set_task(0.1, "te_spray", 0, args, 6, "a", 4)
	check_bubblezone(id, vec, aimvec, speed1, speed2, radius)
}
//----------------------------------------------------------------------------------------------
public te_spray(args[])
{
	// Throws a shower of sprites or models
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(120)			// TE_SPRAY
	write_coord(args[0])		// start pos
	write_coord(args[1])
	write_coord(args[2])
	write_coord(args[3])		// velocity
	write_coord(args[4])
	write_coord(args[5])
	write_short(g_spriteBubble)	// spr
	write_byte(4)		// count
	write_byte(100)	// speed
	write_byte(100)	// noise
	write_byte(1)		// rendermode
	message_end()
}
//----------------------------------------------------------------------------------------------
check_bubblezone(id, vec[], aimvec[], speed1, speed2, radius)
{
	new tbody, tid
	get_user_aiming(id, tid, tbody, 550)

	if ( tid <= 0 || tid > SH_MAXSLOTS )
		return

	new FFOn = get_cvar_num("mp_friendlyfire")
	new CsTeams:idTeam = cs_get_user_team(id)

	if ( FFOn )
		bubble_victim(tid, id)
	else if ( idTeam != cs_get_user_team(tid) )
		bubble_victim(tid, id)

	new bubblevec1[3], bubblevec2[3], length

	bubblevec1[0] = aimvec[0]-vec[0]
	bubblevec1[1] = aimvec[1]-vec[1]
	bubblevec1[2] = aimvec[2]-vec[2]

	length = sqrt(bubblevec1[0]*bubblevec1[0] + bubblevec1[1]*bubblevec1[1] + bubblevec1[2]*bubblevec1[2])

	//Make sure 0 is not returned so we don't devide by it
	if ( length == 0 ) length++

	bubblevec2[0] = bubblevec1[0]*speed2/length
	bubblevec2[1] = bubblevec1[1]*speed2/length
	bubblevec2[2] = bubblevec1[2]*speed2/length

	bubblevec1[0] = bubblevec1[0]*speed1/length
	bubblevec1[1] = bubblevec1[1]*speed1/length
	bubblevec1[2] = bubblevec1[2]*speed1/length

	bubblevec1[0] += vec[0]
	bubblevec1[1] += vec[1]
	bubblevec1[2] += vec[2]

	bubblevec2[0] += vec[0]
	bubblevec2[1] += vec[1]
	bubblevec2[2] += vec[2]

	new origin[3]

	for ( new i = 1; i <= SH_MAXSLOTS; i++ )
	{
		if ( is_user_alive(i) && i != id && (FFOn || idTeam != cs_get_user_team(i)) )
		{
			get_user_origin(i, origin)

			if ( get_distance(origin, bubblevec1) < radius )
				bubble_victim(i, id)
			else if ( get_distance(origin, bubblevec2) < radius )
				bubble_victim(i, id)
		}
	}
}
//----------------------------------------------------------------------------------------------
public bubble_victim(id, killer)
{
	if ( g_isBubbling[id] )
		return

	g_isBubbling[id] = true

	emit_sound(id, CHAN_ITEM, "misc/bubbles.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

	new args[2]
	args[0] = id
	args[1] = killer
	set_task(0.3, "drowning", 451, args, 2, "a", get_cvar_num("aquaman_numbubbles"))
	set_task(0.7, "drown_scream", 0, args, 2)
	set_task(5.5, "stopFireSound", 0, args, 2)
}
//----------------------------------------------------------------------------------------------
public drowning(args[])
{
	new rx, ry, rz, forigin[3]
	new id = args[0]
	new killer = args[1]

	rx = random_num(-30, 30)
	ry = random_num(-30, 30)
	rz = random_num(-30, 30)

	get_user_origin(id, forigin)

	// additive sprite, plays 1 cycle
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(17)				// TE_SPRITE
	write_coord(forigin[0]+rx)	// position
	write_coord(forigin[1]+ry)
	write_coord(forigin[2]+10+rz)
	write_short(g_spriteBubble)	// sprite index
	write_byte(30)				// scale in 0.1's
	write_byte(200)			// brightness
	message_end()

	if ( !is_user_alive(id) )
		return

	if ( !g_hasAquaman[id] )
		entity_set_float(id, EV_FL_air_finished, entity_get_float(id, EV_FL_air_finished) - 1.0)

	new health = get_user_health(id)
	new damage = get_cvar_num("aquaman_bubbledamage")

	if ( health - damage  <= 0 )
		sh_extradamage(id, killer, damage, "bubble attack")
	else
		//Prevents the shExtraDamage from saying you attacked a teammate for every cycle of the loop
		set_user_health(id, health - damage)
}
//----------------------------------------------------------------------------------------------
public drown_scream(args[])
{
	emit_sound(args[0], CHAN_AUTO, "scientist/scream1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
}
//----------------------------------------------------------------------------------------------
public stopFireSound(args[])
{
	new sndStop=(1<<5)
	g_isBubbling[args[0]] = false
	emit_sound(args[0], CHAN_ITEM, "vox/_period.wav", 1.0, ATTN_NORM, sndStop, PITCH_NORM)
}
//----------------------------------------------------------------------------------------------
public client_connecct(id)
{
	g_hasAquaman[id] = false
	g_isBubbling[id] = false
}
//----------------------------------------------------------------------------------------------