// DRACULA!

/* CVARS - copy and paste to shconfig.cfg

//Dracula
dracula_level 0
dracula_pctperlev 0.03	//What percent of damage to give back per level of player

*/

// v1.17.5 - JTP - Added code to allow you to regen to your max heatlh

#include <amxmodx>
#include <shero>

// GLOBAL VARIABLES
new g_heroName[]="Dracula"
new g_heroID
new bool:g_hasDraculaPower[SH_MAXSLOTS+1]
new g_playersMaxHealth[SH_MAXSLOTS+1]
new Float:g_multiplier
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Dracula", "2.0", "{HOJ} Batman/JTP10181")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("dracula_level", "0")
	register_cvar("dracula_pctperlev", "0.03")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	g_heroID = sh_create_hero(g_heroName)
	sh_hero_info(g_heroID, "Vampiric Drain", "Gain HPs by shooting people - More HPs per level")
	sh_hero_bind(g_heroID, false)
	sh_hero_level(g_heroID, get_cvar_num("dracula_level"))

	// REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
	// GET MORE ENERGY!
	register_event("Damage", "dracula_damage", "b", "2!0")

	g_multiplier = get_cvar_float("dracula_pctperlev")
}
//----------------------------------------------------------------------------------------------
public sh_hero_init(id, heroID, mode)
{
	// See if this hero is the same that's being init
	if ( g_heroID == heroID )
		g_hasDraculaPower[id] = (mode!=0)

	// Re-check each time user changes heroes
	if ( g_hasDraculaPower[id] )
	{
		if ( sh_max_hp(id) < 100 )
			g_playersMaxHealth[id] = 100
		else
			g_playersMaxHealth[id] = sh_max_hp(id)
	}
}
//----------------------------------------------------------------------------------------------
public dracula_damage(id)
{
	if ( !sh_server_info(SH_MODACTIVE) || !is_user_connected(id) )
		return

	new attacker = get_user_attacker(id)

	if ( attacker <= 0 || attacker > SH_MAXSLOTS )
		return

	if ( g_hasDraculaPower[attacker] && is_user_alive(attacker) && attacker != id )
	{
		new damage = read_data(2)

		//Add some HP back!
		new giveHps = floatround(damage * g_multiplier * sh_get_user_lvl(attacker))

		if ( get_user_health(attacker) < g_playersMaxHealth[attacker] && giveHps > 0 )
		{
			new alphanum = damage * 2

			if ( alphanum > 200 )
				alphanum = 200
			else if ( alphanum < 40 )
				alphanum = 40

			//Red Screen Flash
			sh_screenflash(attacker, 255, 10, 10, 10, alphanum)

			sh_addhp(attacker, giveHps, g_playersMaxHealth[attacker])
		}
	}
}
//----------------------------------------------------------------------------------------------
public client_connect(id)
{
	g_hasDraculaPower[id] = false
}
//----------------------------------------------------------------------------------------------