// MAGNETO! from X-men. The master of magnetism.

/* CVARS - copy and paste to shconfig.cfg

//Magneto
magneto_level 10
magneto_cooldown 45		//Time delay bewtween automatic uses
magneto_boost 125		//How much of an upward throw to give victim for his weapons
magneto_giveglock 1		//Give the poor victim a glock?

*/

#include <amxmodx>
#include <engine>
#include <shero>

// GLOBAL VARIABLES
new g_heroName[]="Magneto"
new g_heroID
new bool:g_hasMagneto[SH_MAXSLOTS+1]
new g_spriteLightning
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Magneto", "2.0", "AssKicR/JTP10181")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("magneto_level", "10")
	register_cvar("magneto_cooldown", "45")
	register_cvar("magneto_boost", "125")
	register_cvar("magneto_giveglock", "1")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	g_heroID = sh_create_hero(g_heroName)
	sh_hero_info(g_heroID, "Magnetic Control", "Strip and Get a players guns when they shoot you")
	sh_hero_bind(g_heroID, false)
	sh_hero_level(g_heroID, get_cvar_num("magneto_level"))

	// REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
	// GET MORE GUNZ!
	register_event("Damage", "magneto_damage", "b", "2!0")

	//Shield Restrict
	//shSetShieldRestrict(gHeroName)
}
//----------------------------------------------------------------------------------------------
public plugin_precache()
{
	precache_sound("ambience/deadsignal1.wav")
	g_spriteLightning = precache_model("sprites/lgtning.spr")
}
//----------------------------------------------------------------------------------------------
public sh_hero_init(id, heroID, mode)
{
	// See if this hero is the same that's being init
	if ( g_heroID == heroID )
	{
		//Reset thier shield restrict status
		//Shield restrict MUST be before weapons are given out
		//shResetShield(id)

		g_hasMagneto[id] = (mode != 0)
	}
}
//----------------------------------------------------------------------------------------------
public sh_new_spawn(id)
{
	sh_uset(id, g_heroID, 0)
}
//----------------------------------------------------------------------------------------------
public magneto_damage(id)
{
	if ( !sh_server_info(SH_MODACTIVE) || !g_hasMagneto[id] || sh_ustatus(id, g_heroID) || !is_user_alive(id) )
		return

	new weapon, bodypart, attacker = get_user_attacker(id, weapon, bodypart)

	// Don't want to do anything with some weapons
	if ( weapon == CSW_C4 || weapon == CSW_KNIFE || weapon == CSW_HEGRENADE || weapon == CSW_SMOKEGRENADE || weapon == CSW_FLASHBANG )
		return

	if ( is_user_alive(id) && is_user_alive(attacker) && id != attacker )
	{
		new damage = read_data(2)

		sh_utimer(id, g_heroID, get_cvar_float("magneto_cooldown"))

		// Disarm enemy and get their guns!
		playSound(id)
		playSound(attacker)
		magneto_disarm(id, attacker)

		// Screen Flash
		new alphanum = damage * 2
		if (alphanum > 200)
			alphanum = 200
		else if (alphanum < 40)
			alphanum = 40
		sh_screenflash(attacker, 100, 100, 100, 10, alphanum)
	}
}
//----------------------------------------------------------------------------------------------
public magneto_disarm(id, victim)
{
	new Float:velocity[3]

	entity_get_vector(victim, EV_VEC_velocity, velocity)
	velocity[2] = velocity[2] + get_cvar_num("magneto_boost")

	// Give em an upwards Jolt
	entity_set_vector(victim, EV_VEC_velocity, velocity)

	new iweapons[32], inum, weapname[24]
	get_user_weapons(victim, iweapons, inum)

	for ( new a = 0; a < inum; a++ )
	{
		//Don't want to do anything with some weapons
		if ( iweapons[a] == CSW_C4 || iweapons[a] == CSW_KNIFE || iweapons[a] == CSW_HEGRENADE || iweapons[a] == CSW_SMOKEGRENADE || iweapons[a] == CSW_FLASHBANG )
			continue

		get_weaponname(iweapons[a], weapname, 23)

		engclient_cmd(victim, "drop", weapname)
		sh_GiveWeapon(id, weapname)
	}

	new iCurrent = -1
	new Float:weapvel[3]

	while ( (iCurrent = find_ent_by_class(iCurrent, "weaponbox")) > 0 )
	{
		// Skip anything not owned by this client
		if ( entity_get_edict(iCurrent, EV_ENT_owner) != victim )
			continue

		entity_get_vector(iCurrent, EV_VEC_velocity, weapvel)

		// If Velocities are all Zero its on the ground already and should stay there
		if ( weapvel[0] == 0.0 && weapvel[1] == 0.0 && weapvel[2] == 0.0 )
			continue

		remove_entity(iCurrent)
	}

	if ( get_cvar_num("magneto_giveglock") )
		sh_GiveWeapon(victim, "weapon_glock18", true)
	else
		engclient_cmd(victim, "weapon_knife")

	lightning_effect(id, victim)

	client_print(victim, print_chat, "[SH] Magneto's power has removed your weapons")
}
//----------------------------------------------------------------------------------------------
public lightning_effect(id, victim)
{
	// Lightning effect
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(8)			// TE_BEAMENTS
	write_short(id)		// start entity
	write_short(victim)		// entity
	write_short(g_spriteLightning)	// model
	write_byte(0)		// starting frame
	write_byte(15)		// frame rate
	write_byte(10)		// life
	write_byte(10)		// line width
	write_byte(10)		// noise amplitude
	write_byte(255)	// r, g, b
	write_byte(255)	// r, g, b
	write_byte(255)	// r, g, b
	write_byte(255)	// brightness
	write_byte(0)		// scroll speed
	message_end()
}
//----------------------------------------------------------------------------------------------
public playSound(id)
{
	new parm[1]
	parm[0] = id

	emit_sound(id, CHAN_AUTO, "ambience/deadsignal1.wav", 1.0, ATTN_NORM, 0, PITCH_HIGH)
	set_task(1.5, "stopSound", 0, parm, 1)
}
//----------------------------------------------------------------------------------------------
public stopSound(parm[])
{
	new sndStop = (1<<5)
	emit_sound(parm[0], CHAN_AUTO, "ambience/deadsignal1.wav", 1.0, ATTN_NORM, sndStop, PITCH_NORM)
}
//----------------------------------------------------------------------------------------------