// MYSTIQUE! - BASED ON Vexds model changer

/* CVARS - copy and paste to shconfig.cfg

//Mystique
mystique_level 0
mystique_cooldown 0			//Cooldown time between morphs
mystique_maxtime 0			//Max time you can be morphed
mystique_toggle 1			//Should the key be a toggle or do they need to hold it down

*/

#include <amxmodx>
#include <cstrike>
#include <shero>

// GLOBAL VARIABLES
new g_heroName[]="Mystique"
new g_heroID
new bool:g_morphed[SH_MAXSLOTS+1]
new g_soundMystique[]="ambience/disgusting.wav"
new g_ctSkins[4][10]={"sas", "gsg9", "urban", "gign"}
new g_tSkins[4][10]={"arctic", "leet", "guerilla", "terror"}
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Mystique", "1.18", "{HOJ} Batman")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("mystique_level", "0")
	register_cvar("mystique_cooldown", "0")
	register_cvar("mystique_maxtime",  "0")
	register_cvar("mystique_toggle",  "1")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	g_heroID = sh_create_hero(g_heroName)
	sh_hero_info(g_heroID, "Morph into Enemy", "Hold Down a Power Key to Look Like the Enemy - Release the Key to Look Like Yourself!")
	sh_hero_bind(g_heroID, true)
	sh_hero_level(g_heroID, get_cvar_num("mystique_level"))

	// REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
	// DEATH
	register_event("DeathMsg", "mystique_death", "a")
}
//----------------------------------------------------------------------------------------------
public plugin_precache()
{
	precache_sound(g_soundMystique)
}
//----------------------------------------------------------------------------------------------
public sh_hero_init(id, heroID, mode)
{
	// See if this hero is the same that's being init
	if ( g_heroID == heroID )
	{
		if ( !mode && g_morphed[id] && is_user_connected(id) ) mystique_unmorph(id)
	}
}
//----------------------------------------------------------------------------------------------
// RESPOND TO KEYDOWN
public sh_hero_key(id, heroID, key)
{
	if ( g_heroID != heroID ) return

	if ( key == SH_KEYDOWN )
	{
		// If in toggle mode change this to a keyup event
		if ( get_cvar_num("mystique_toggle") && g_morphed[id] )
		{
			mystique_unmorph(id)
			return
		}

		if ( !is_user_alive(id) ) return

		// Let them know they already used their ultimate if they have
		if ( sh_ustatus(id, g_heroID) )
		{
			playSoundDenySelect(id)
			return
		}

		new Float:mystiqueCooldown = get_cvar_float("mystique_cooldown")
		if ( mystiqueCooldown > 0.0 ) sh_utimer(id, g_heroID, mystiqueCooldown)

		mystique_morph(id)

		new Float:mystiqueMaxTime = get_cvar_float("mystique_maxtime")
		if ( mystiqueMaxTime > 0.0 )
		{
			set_task(mystiqueMaxTime, "forceUnmorph", id)
		}
	}
	else
	{
		// toggle mode - keyup doesn't do anything!
		if ( get_cvar_num("mystique_toggle") ) return

		mystique_unmorph(id)
	}
}
//----------------------------------------------------------------------------------------------
public mystique_morph(id)
{
	new newSkin[32]

	if ( !is_user_alive(id) || g_morphed[id] ) return

	new num = random_num(0,3)

	if ( cs_get_user_team(id) == CS_TEAM_T )
	{
		copy(newSkin, 31, g_ctSkins[num])
	}
	else
	{
		copy(newSkin, 31, g_tSkins[num])
	}

	cs_set_user_model(id, newSkin)

	g_morphed[id] = true
	mystique_sound(id)

	// Message
	set_hudmessage(200, 200, 0, -1.0, 0.45, 2, 0.02, 4.0, 0.01, 0.1, 86)
	show_hudmessage(id, "Mystique - YOU NOW LOOK LIKE THE ENEMY")
}
//----------------------------------------------------------------------------------------------
public mystique_unmorph(id)
{
	if ( g_morphed[id] )
	{
		set_hudmessage(200, 200, 0, -1.0, 0.45, 2, 0.02, 4.0, 0.01, 0.1, 86)
		show_hudmessage(id, "Mystique - RETURNED TO SELF")
		remove_task(id)

		cs_reset_user_model(id)

		g_morphed[id] = false
		mystique_sound(id)
	}
}
//----------------------------------------------------------------------------------------------
public mystique_sound(id)
{
	new SND_STOP = (1<<5)
	emit_sound(id, CHAN_AUTO, g_soundMystique, 0.2, ATTN_NORM, SND_STOP , PITCH_NORM)
	emit_sound(id, CHAN_AUTO, g_soundMystique, 0.2, ATTN_NORM, 0, PITCH_NORM)
}
//----------------------------------------------------------------------------------------------
public forceUnmorph(id)
{
	client_print(id, print_chat, "[SH](Mystique) Your morph power has worn off")
	mystique_unmorph(id)
}
//----------------------------------------------------------------------------------------------
public mystique_death()
{
	new id = read_data(2)
	mystique_unmorph(id)
}
//----------------------------------------------------------------------------------------------
public client_connect(id)
{
	g_morphed[id] = false
}
//----------------------------------------------------------------------------------------------