#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <cstrike>
#include <shero>

#if AMXX_VERSION_NUM >= 175
	#pragma reqlib shero
	#if !defined AMXMODX_NOAUTOLOAD
		#pragma loadlib shero
	#endif
#else
	#pragma library shero
#endif

#define CSTRIKE
//----------------------------------------------------------------------------------------------
//* GLOBALS *//
//----------------------------------------------------------------------------------------------

new PLUGIN_NAME[]    = "SuperHero Mod";
new PLUGIN_VERSION[] = "2.000";
new PLUGIN_AUTHORS[] = "AssKicR/Freecode/JTP10181/vittu";

new g_sheroMenu;
new g_HeroCall;
new gmsgScoreInfo, gmsgDeathMsg, gmsgDamage

new bool:inTimer[SH_MAXSLOTS+1][33];
new gReloadTime[SH_MAXSLOTS+1];
new gPlayerGodTimer[SH_MAXSLOTS+1]

//From multiplayer/dlls/player.cpp
#define ARMOR_RATIO 0.2    // Armor Takes 80% of the damage (0.2 in the SDK)
#define ARMOR_BONUS 0.5    // Each Point of Armor is worth 1/x points of health (0.5 in the SDK)

//----------------------------------------------------------------------------------------------
public plugin_natives()
{
	//* NATIVES *//
	register_library("SheroPlugin");
	register_native("sh_utimer","utimer",0);
	register_native("sh_ustatus","ustatus",0);
	register_native("sh_uset","uset",0);
	register_native("sh_screenflash","screenFlash",0);
	register_native("sh_screenshake","ScreenShake",0);
	register_native("sh_logkill","logKill",0);
	register_native("sh_addhp","addhp",0);
	register_native("sh_reloadammo","reloadAmmo",0);
	register_native("sh_extradamage","ExtraDamage",0);
	register_native("sh_godplayer","godPlayer",0);
}
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	register_plugin(PLUGIN_NAME, PLUGIN_VERSION, PLUGIN_AUTHORS);
	
	//* MENU *//
	g_sheroMenu = menu_create(PLUGIN_NAME,"handleMenu");
	g_HeroCall = menu_makecallback("CanChooseHero");
	register_clcmd("sh_menu","showMenu");
	
	// * ADMIN COMMANDS *//
	register_clcmd("sh_setxp","set_xp",ADMIN_LEVEL_A,"Set users xp");
	register_clcmd("sh_setlevel","set_level",ADMIN_LEVEL_A,"Set users level");
	
	register_clcmd("say","HandleSay")
	register_clcmd("say_team","HandleSay")
	
	
	//* GLOBAL *//
	gmsgScoreInfo = get_user_msgid("ScoreInfo")
	gmsgDeathMsg = get_user_msgid("DeathMsg")
	gmsgDamage = get_user_msgid("Damage")
	
	set_task(1.0, "TimerAll", 0, "", 0, "b")
}
//----------------------------------------------------------------------------------------------
public plugin_cfg()
{
	buildMenu();
}
//----------------------------------------------------------------------------------------------
public plugin_precache()
{
	// Default Sounds
	precache_sound( "common/wpn_denyselect.wav" )
	precache_sound( "plats/elevbell1.wav")
}
//----------------------------------------------------------------------------------------------
public sInfo(info)
{
	return sh_server_info(info);
}
//----------------------------------------------------------------------------------------------
public handleMenu(id, menu, item)
{
	if(!sInfo(SH_MODACTIVE)) return PLUGIN_CONTINUE;
	
	if( item < 0 ) return PLUGIN_CONTINUE;
	
	
	new cmd[5], heroName[64], iName[64];
	new iaccess, callback;
	
	menu_item_getinfo(menu, item, iaccess, cmd,4, iName, 63,callback);
	new idHero = str_to_num(cmd);
	
	sh_get_hero_name(idHero,heroName, 63);
	
	sh_add_user_hero(id,heroName);
	new page = (item < 7)? 0 : floatround((item/7.0),floatround_floor);
	
	if(sh_get_user_lvl(id) > sh_user_heronum(id))
		menu_display(id, menu, page);
	
	return PLUGIN_HANDLED;
}
//----------------------------------------------------------------------------------------------
public buildMenu()
{
	if(!sInfo(SH_MODACTIVE)) return PLUGIN_CONTINUE;
	
	new x;
	new power[256];
	new name[64];
	
	new fItem[326];
	new cmd[5];
	
	for(x = 1; x <= sInfo(SH_HEROCOUNT); x++)
	{
		new i = sh_get_hero_name(x,name,63);
		sh_get_hero_power(x,power,255)
		if(!i) continue;

		format(fItem,325,"%s        %s",name,power);
		format(cmd,4,"%d",x);
		menu_additem(g_sheroMenu , fItem , cmd , 0 , g_HeroCall);
	}
	
	
	return PLUGIN_HANDLED;
}
//----------------------------------------------------------------------------------------------
public showMenu(id)
{
	new heroes = sh_user_heronum(id);
	new lvl = sh_get_user_lvl(id);
	new ban = sh_get_user_ban(id);
	
	
	if(ban)
	{
		client_print(id,3,"[SH] You are banned from using SuperHeroes.");
	}
	else if( heroes == lvl)
	{
		client_print(id,3,"[SH] You have no hero slots.");
	}
	else if( heroes < lvl)
	{
		menu_display(id, g_sheroMenu, 0);
	}
}
//----------------------------------------------------------------------------------------------		
public CanChooseHero(id, menu, item)
{

	if( item < 0 ) return PLUGIN_CONTINUE;
	
	new cmd[5], name[32], iName[64], power[256], fItem[326];
	new access, callback;
	
	menu_item_getinfo(menu, item, access, cmd,4, iName, 63,callback);
	
	new idHero = str_to_num(cmd);
	new lvl = sh_get_hero_lvl(idHero);
	new iLvl = sh_get_user_lvl(id);
	new binds = sh_get_user_binds(id);
	new sBind = sInfo(SH_MAXBINDPOWERS);
	
	sh_get_hero_name(idHero,name,31);
	sh_get_hero_power(idHero,power,255);

	
	if (sh_check_hero(id, idHero)) // User exists
	{
		format(fItem,325,"%-30s Hero already in your'e list",name);
		menu_item_setname(menu, item, fItem );
		return ITEM_DISABLED;
	}
	else if( lvl > iLvl ) // Hero higher level
	{
		format(fItem,325,"%-30s Level %d needed",name,lvl);
		menu_item_setname(menu, item, fItem );
		return ITEM_DISABLED;
	}
	else if (binds >= sBind && sh_get_hero_bind(idHero)) // Hero binds limit reached
	{
		format(fItem,325,"%-30s Bind limit reached",name);
		menu_item_setname(menu, item, fItem );
		return ITEM_DISABLED;
	}
	else
	{
		format(fItem,325,"\r%-30s \w%s",name,power);
		menu_item_setname(menu, item, fItem );
		return ITEM_ENABLED;
	}
		
		
	return PLUGIN_HANDLED;
}
//----------------------------------------------------------------------------------------------
public set_xp(id)
{
	if(!sInfo(SH_MODACTIVE)) return PLUGIN_CONTINUE;
	
	if (read_argc() > 3) 
	{
		console_print(id,"[SH] Too many arguments supplied. Do not use a space in the name.")
		console_print(id,"[SH] You only need to put in a partial name to use this command.")
		return PLUGIN_HANDLED
	}

	new cmd[32], arg[32], arg2[32]
	new name2[32]

	read_argv(0,cmd,31)
	read_argv(1,arg,31)
	read_argv(2,arg2,31)

	if ( !(isdigit(arg2[0]) || (equal(arg2[0],"-",1) && isdigit(arg2[1]) ) ) ) 
	{
		console_print(id,"[SH] Second argument must be a XP value.")
		return PLUGIN_HANDLED
	}

	get_user_name(id,name2,31)
	new xp = str_to_num(arg2)


	if (arg[0]=='@')
	{
		new players[32], inum
		if (equali("T",arg[1])) 
		{
			copy(arg[1],31,"TERRORIST")
		}
		if (equali("ALL",arg[1]))
		{
			get_players(players,inum)
		}
		else 
		{
			get_players(players,inum,"e",arg[1])
		}

		if (inum == 0) 
		{
			console_print(id,"[SH] No clients in such team")
			return PLUGIN_HANDLED
		}
		
		for(new a = 0;a < inum; a++) 
		{
			sh_set_user_xp(players[a],xp);
		}

		console_print(id,"[SH] Set %d XP on %s players",xp,arg[1])

		
	}
	else 
	{
		new player = cmd_target(id,arg,2)
		if (!player) return PLUGIN_HANDLED
			
		sh_set_user_xp(player,xp);
	}
	
	return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public set_level(id)
{
	if(!sInfo(SH_MODACTIVE)) return PLUGIN_CONTINUE;
	
	if (read_argc() > 3) 
	{
		console_print(id,"[SH] Too many arguments supplied. Do not use a space in the name.")
		console_print(id,"[SH] You only need to put in a partial name to use this command.")
		return PLUGIN_HANDLED
	}

	new cmd[32], arg[32], arg2[32]
	new name2[32]

	read_argv(0,cmd,31)
	read_argv(1,arg,31)
	read_argv(2,arg2,31)

	if ( !(isdigit(arg2[0]) || (equal(arg2[0],"-",1) && isdigit(arg2[1]) ) ) ) 
	{
		console_print(id,"[SH] Second argument must be a Level value.")
		return PLUGIN_HANDLED
	}

	get_user_name(id,name2,31)
	new level = str_to_num(arg2)


	if (arg[0]=='@')
	{
		new players[32], inum
		if (equali("T",arg[1])) 
		{
			copy(arg[1],31,"TERRORIST")
		}
		if (equali("ALL",arg[1]))
		{
			get_players(players,inum)
		}
		else 
		{
			get_players(players,inum,"e",arg[1])
		}

		if (inum == 0) 
		{
			console_print(id,"[SH] No clients in such team")
			return PLUGIN_HANDLED
		}
		
		for(new a = 0;a < inum; a++) 
		{
			sh_set_user_lvl(players[a],level);
		}

		console_print(id,"[SH] Set %d XP on %s players",level,arg[1])

		
	}
	else 
	{
		new player = cmd_target(id,arg,2)
		if (!player) return PLUGIN_HANDLED
			
		sh_set_user_lvl(player,level);
	}
	
	return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public HandleSay(id)
{
	new said[192]
	read_args(said,191)
	remove_quotes(said)

	if(!sInfo(SH_MODACTIVE)) return PLUGIN_CONTINUE;

	if (equali(said,"/showmenu") || equali(said, "showmenu"))
	{
		showMenu(id)
		return PLUGIN_HANDLED
	}
	return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
// REGISTER_NATIVES //
//----------------------------------------------------------------------------------------------
public utimer(id,numparams) // sh_utimer(id,heroID,float:utime);
{
	if ( !sh_server_info(SH_MODACTIVE) ) return PLUGIN_CONTINUE
	if(numparams != 3)
		return log_error(AMX_ERR_NATIVE, "Bad native parameters");
		
	new Float: utime = get_param_f(3); // time
	new pID = get_param(1); // user id
	new heroID = get_param(2);
	
	if(utime > 0.0 && is_user_connected(pID))
	{
		inTimer[pID][heroID] = true;
		new param[2];
		param[0] = pID;
		param[1] = heroID;
		set_task(utime,"timerStatus",0,param,2);
	}
	else
	{
		return log_error(AMX_ERR_NATIVE, "Bad native parameters");
	}
	
	return PLUGIN_HANDLED;
}
//----------------------------------------------------------------------------------------------
public timerStatus(param[])
{
	inTimer[param[0]][param[1]] = false;	
	return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public ustatus(id, numparams) // sh_ustatus(id,heroID);
{
	if ( !sh_server_info(SH_MODACTIVE) ) return PLUGIN_CONTINUE
	if(numparams != 2)
		return log_error(AMX_ERR_NATIVE, "Bad native parameters");
		
	new pID = get_param(1);
	new heroID = get_param(2);
	
	
	return inTimer[pID][heroID];
}
//----------------------------------------------------------------------------------------------
public uset(id, numparams) // sh_uset(id,heroID,set);
{
	if ( !sh_server_info(SH_MODACTIVE) ) return PLUGIN_CONTINUE
	if(numparams != 3)
		return log_error(AMX_ERR_NATIVE, "Bad native parameters");
		
	new pID = get_param(1);
	new heroID = get_param(2);
	new set = get_param(3);
	
	inTimer[pID][heroID] = set ? true : false;
	
	return PLUGIN_HANDLED;
}
//----------------------------------------------------------------------------------------------
public screenFlash(id, numparams)
{
	if ( !sh_server_info(SH_MODACTIVE) ) return PLUGIN_CONTINUE
	if(numparams != 6)
		return log_error(AMX_ERR_NATIVE, "Bad native parameters");
		
	new pID = get_param(1);
	new red = get_param(2);
	new green = get_param(3);
	new blue = get_param(4);
	new decisecs = get_param(5);
	new alpha = get_param(6);
	
	if (!is_user_connected(pID)) return PLUGIN_CONTINUE
	message_begin(MSG_ONE_UNRELIABLE,get_user_msgid("ScreenFade"),{0,0,0},pID)
	write_short( 1<<decisecs ) // fade lasts this long duration
	write_short( 1<<decisecs ) // fade lasts this long hold time
	write_short( 1<<12 ) // fade type (in / out)
	write_byte( red ) // fade red
	write_byte( green ) // fade green
	write_byte( blue ) // fade blue
	write_byte( alpha ) // fade alpha
	message_end()
	
	return PLUGIN_HANDLED;
}
//----------------------------------------------------------------------------------------------
public ScreenShake(id, numparams)
{
	if ( !sh_server_info(SH_MODACTIVE) ) return PLUGIN_CONTINUE
	if(numparams != 4)
		return log_error(AMX_ERR_NATIVE, "Bad native parameters");
	
	new pID = get_param(1);
	new amplitude = get_param(2);
	new duration = get_param(3);
	new frequency = get_param(4);
	
	if (!is_user_connected(pID)) return PLUGIN_CONTINUE
	message_begin(MSG_ONE_UNRELIABLE,get_user_msgid("ScreenShake"),{0,0,0},pID)
	write_short( 1<<amplitude )// amplitude
	write_short( 1<<duration )// duration
	write_short( 1<<frequency )// frequency
	message_end()
	
	return PLUGIN_HANDLED;
}
//----------------------------------------------------------------------------------------------
public logKill(id, numparams)
{
	if ( !sh_server_info(SH_MODACTIVE) ) return PLUGIN_CONTINUE
	if(numparams != 3)
		return log_error(AMX_ERR_NATIVE, "Bad native parameters");
		
	new pID = get_param(1);
	new vID = get_param(2);
	new weaponDescription[32];
	get_string(3, weaponDescription, 31);
	new namea[32],namev[32],authida[35],authidv[35],teama[16],teamv[16]

	//Info On Attacker
	get_user_name(pID,namea,31)
	get_user_team(pID,teama,15)
	get_user_authid(pID,authida,34)

	//Info On Victim
	get_user_name(vID,namev,31)
	get_user_team(vID,teamv,15)
	get_user_authid(vID,authidv,34)

	//Log This Kill
	if ( pID != vID ) {
		log_message("^"%s<%d><%s><%s>^" killed ^"%s<%d><%s><%s>^" with ^"%s^"",
			namea,get_user_userid(pID),authida,teama,namev,get_user_userid(vID),authidv,teamv, weaponDescription )
	}
	else {
		log_message("^"%s<%d><%s><%s>^" committed suicide with ^"%s^"",
			namea,get_user_userid(pID),authida,teama, weaponDescription )
	}
	return PLUGIN_HANDLED;
}
//----------------------------------------------------------------------------------------------
public addhp(id, numparams)
{
	if ( !sh_server_info(SH_MODACTIVE) || !sh_server_info(SH_INROUND) ) return PLUGIN_CONTINUE
	if(numparams != 3)
		return log_error(AMX_ERR_NATIVE, "Bad native parameters");
	
	new pID = get_param(1);
	new hitPoints = get_param(2);
	new maxHealth = get_param(3);
	
	new currentHealth = get_user_health(pID);

	if ( currentHealth > maxHealth )
		maxHealth = currentHealth;
	else if ( currentHealth < maxHealth ) 
	{
		new newHealth = min(currentHealth + hitPoints, maxHealth);
		if ( currentHealth != newHealth ) 
			set_user_health(pID, newHealth);
	}
	return PLUGIN_HANDLED;
}
//----------------------------------------------------------------------------------------------
public reloadAmmo(id, numparams)
{
	if ( !sh_server_info(SH_MODACTIVE) ) return PLUGIN_CONTINUE
	if(numparams != 2)
		return log_error(AMX_ERR_NATIVE, "Bad native parameters");
		
	new pID = get_param(1);
	new dropwpn = get_param(2);

	if (gReloadTime[pID] >= get_systime() - 1) return PLUGIN_CONTINUE
	gReloadTime[pID] = get_systime()

	new clip, ammo, wpn[32]
	new wpnid = get_user_weapon(pID, clip, ammo)

	if ( wpnid == CSW_C4 || wpnid == CSW_KNIFE ) return PLUGIN_CONTINUE
	if ( wpnid == CSW_HEGRENADE || wpnid == CSW_SMOKEGRENADE || wpnid == CSW_FLASHBANG) return PLUGIN_CONTINUE

	if ( clip == 0 ) 
	{
		get_weaponname(wpnid,wpn,31)
		if ( dropwpn ) 
		{
			engclient_cmd(pID,"drop",wpn)
			give_item(pID, wpn)
			engclient_cmd(pID, wpn)
			//setSpeedPowers(id, false)
		}
		else
		{
			new iWPNidx = -1
			while ((iWPNidx = find_ent_by_class(iWPNidx, wpn)) != 0)
			{
				if (pID == entity_get_edict(iWPNidx, EV_ENT_owner))
				{
					#if defined CSTRIKE
						cs_set_weapon_ammo(iWPNidx, sh_ClipAmmoCS(wpnid))
					#endif
					break
				}
			}
		}
	}
	
	return PLUGIN_HANDLED;
}
//----------------------------------------------------------------------------------------------
public ExtraDamage(id, numparams)
{
	if ( !sh_server_info(SH_MODACTIVE) ) return PLUGIN_CONTINUE
	if(numparams != 5)
		return log_error(AMX_ERR_NATIVE, "Bad native parameters");
		
	//shExtraDamage(id, attacker, damage, weaponDescription[], headshot = 0 )
	
	new pID = get_param(1);
	new attacker = get_param(2);
	new damage = get_param(3);
	new weaponDescription[32];
	get_string(4, weaponDescription, 31);
	new headshot = get_param(5);
	
	if ( !is_user_alive(pID) || !is_user_connected(attacker) ) return PLUGIN_CONTINUE
	if ( get_user_godmode(pID) ) return PLUGIN_CONTINUE
	if ( damage <= 0 ) return PLUGIN_CONTINUE

	// *** Damage calculation due to armor from: multiplayer/dlls/player.cpp ***
	new Float:flNewDamage = float(damage) * ARMOR_RATIO
	new Float:flArmor = (float(damage) - flNewDamage) * ARMOR_BONUS
	new plrArmor = get_user_armor(pID)

	// Does this use more armor than we have figured for?
	if ( flArmor > float(plrArmor) ) {
		flArmor = float(plrArmor)
		flArmor *= (1/ARMOR_BONUS)
		flNewDamage = float(damage) - flArmor
		plrArmor = 0
	}
	else {
		plrArmor = floatround(plrArmor - flArmor)
	}

	//Commenting this out so it does the orginal ammount of damage still
	//damage = floatround(flNewDamage)

	//*** End of damage-armor calculations ***

	new userHealth = get_user_health(pID)
	new FFon = get_cvar_num("mp_friendlyfire")
	if (userHealth - damage <= 0 )
	{
		new bool:kill = false
		if (pID == attacker)
		{
			kill = true
		}
		else if (FFon && get_user_team(pID) == get_user_team(attacker))
		{
			kill = true
			sh_set_user_xp(attacker, sh_get_user_xp(attacker) - sh_xpgiven(pID)  )
			set_user_frags(attacker, get_user_frags(attacker) - 1)
			client_print(attacker,print_center,"You killed a teammate")
			
			#if defined CSTRIKE
				new money = cs_get_user_money(attacker)
				if (money != 0) cs_set_user_money(attacker,money - 150,1)
			#endif
		}
		else if (get_user_team(pID) != get_user_team(attacker))
		{
			kill = true
			sh_set_user_xp(attacker, sh_get_user_xp(attacker) + sh_xpgiven(pID)  )
			set_user_frags(attacker, get_user_frags(attacker) + 1)
			
			#if defined CSTRIKE
				new money = cs_get_user_money(attacker)
				if (money < 16000) cs_set_user_money(attacker,money + 300,1)
			#endif
		}

		if (!kill) return PLUGIN_CONTINUE

		//Log the Kill
		sh_logkill(attacker, pID, weaponDescription)

		//Kill the victim and block the messages
		set_msg_block(gmsgDeathMsg,BLOCK_ONCE)
		set_msg_block(gmsgScoreInfo,BLOCK_ONCE)
		user_kill(pID)

		//user_kill removes a frag, this gives it back
		set_user_frags(pID,get_user_frags(pID) + 1)

		//Replaced HUD death message
		message_begin(MSG_ALL,gmsgDeathMsg,{0,0,0},0)
		write_byte(attacker)
		write_byte(pID)
		write_byte(headshot)
		write_string(weaponDescription)
		message_end()

		//Update killers scorboard with new info
		message_begin(MSG_ALL,gmsgScoreInfo)
		write_byte(attacker)
		write_short(get_user_frags(attacker))
		write_short(get_user_deaths(attacker))
		write_short(0)
		write_short(get_user_team(attacker))
		message_end()

		//Update victims scoreboard with correct info
		message_begin(MSG_ALL,gmsgScoreInfo)
		write_byte(pID)
		write_short(get_user_frags(pID))
		write_short(get_user_deaths(pID))
		write_short(0)
		write_short(get_user_team(pID))
		message_end()

	}
	else
	{
		new bool:hurt = false
		if (pID == attacker)
		{
			hurt = true
		}
		else if (FFon && get_user_team(pID) == get_user_team(attacker))
		{
			hurt = true
			new name[33]
			get_user_name(attacker,name,32)
			client_print(0,print_chat,"%s attacked a teammate",name)
		}
		else if (get_user_team(pID) != get_user_team(attacker))
		{
			hurt = true
		}

		if (!hurt) return PLUGIN_CONTINUE

		set_user_health(pID, userHealth - damage)
		set_user_armor(pID, plrArmor)

		new aOrigin[3]
		get_user_origin(attacker, aOrigin)

		//Damage message
		message_begin(MSG_ONE, gmsgDamage, {0,0,0}, pID)
		write_byte(0) // dmg_save
		write_byte(damage) // dmg_take
		write_long(0) // visibleDamageBits
		write_coord(aOrigin[0]) // damageOrigin.x
		write_coord(aOrigin[1]) // damageOrigin.y
		write_coord(aOrigin[2]) // damageOrigin.z
		message_end()
	}
	return PLUGIN_HANDLED;
}
//----------------------------------------------------------------------------------------------
public godPlayer(id, numparams)
{
	if ( !sh_server_info(SH_MODACTIVE) ) return PLUGIN_CONTINUE
	if(numparams != 2)
		return log_error(AMX_ERR_NATIVE, "Bad native parameters");

	new pID = get_param(1);
	new howLong = get_param(2);

	if (!is_user_alive(id)) return PLUGIN_CONTINUE

	if (howLong > gPlayerGodTimer[pID])
	{
		//format(debugt,255,"Has God Mode for %d seconds", howLong)
		//debugMessage(debugt, id, 8)
		sh_Glow(pID,0,0,128)
		set_user_godmode(pID, 1)
		gPlayerGodTimer[pID] = howLong
	}
	return PLUGIN_HANDLED;
}
//----------------------------------------------------------------------------------------------
public TimerAll()
{
	for ( new idt = 1; idt <= SH_MAXSLOTS; idt++ )
	{
		if ( is_user_alive(idt) )
		{
			if ( gPlayerGodTimer[idt] != 0 )
			{
				gPlayerGodTimer[idt]--
				if (gPlayerGodTimer[idt] <= 0 )
				{
					gPlayerGodTimer[idt] = 0
					set_user_godmode(idt, 0)
					sh_Unglow(idt)
				}
			}
		}
		else 
		{
			gPlayerGodTimer[idt] = 0
		}
	}
}